(***** functions to deal with general candidates *****)

(*** a list of all independent components of a tensor in a certain basis
     (does not work with antisymmetric tensors!) ***)
IndepBasisComponents[T_?xTensorQ[inds___], basis_] :=
Union[Flatten[{Simplification[ComponentArray[FreeToBasis[basis][T[inds]]]]}]];

(*** a list of basis tensors for the components ***)
ComponentBasis[T_?xTensorQ[inds___], basis_] :=
Module[{components = IndepBasisComponents[T[inds], basis],
        sepBasis},
       sepBasis = SeparateBasis[basis] /@ components;
       Simplification[TraceBasisDummy[IndexCoefficient[#, T[inds]]& /@ sepBasis]]
      ];

(*** Rules to replace components of a tensor by certain constants ***)
IndepBasisComponentRules[T_?xTensorQ[inds___], basis_] :=
Module[{indepComponents=IndepBasisComponents[T[inds], basis],
        constList},
       constList = Table[GiveSymbol[T, i], {i, Length[indepComponents]}];
       If[FreeQ[$ConstantSymbols,#], DefConstantSymbol[#]]& /@ constList;
       Thread[Rule[indepComponents,constList]]
      ];
